import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogLogsIndexesOrderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/d/logs_indexes_order#id DataDatadogLogsIndexesOrder#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/datadog/d/logs_indexes_order datadog_logs_indexes_order}
*/
export declare class DataDatadogLogsIndexesOrder extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_logs_indexes_order";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/datadog/d/logs_indexes_order datadog_logs_indexes_order} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogLogsIndexesOrderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatadogLogsIndexesOrderConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get indexNames(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
