import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogRolesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Filter all roles by the given string.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/d/roles#filter DataDatadogRoles#filter}
    */
    readonly filter?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/d/roles#id DataDatadogRoles#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataDatadogRolesRoles {
}
export declare function dataDatadogRolesRolesToTerraform(struct?: DataDatadogRolesRoles): any;
export declare class DataDatadogRolesRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatadogRolesRoles | undefined;
    set internalValue(value: DataDatadogRolesRoles | undefined);
    get id(): string;
    get name(): string;
    get userCount(): number;
}
export declare class DataDatadogRolesRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatadogRolesRolesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/datadog/d/roles datadog_roles}
*/
export declare class DataDatadogRoles extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_roles";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/datadog/d/roles datadog_roles} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogRolesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatadogRolesConfig);
    private _filter?;
    get filter(): string;
    set filter(value: string);
    resetFilter(): void;
    get filterInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _roles;
    get roles(): DataDatadogRolesRolesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
