import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogSyntheticsLocationsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/datadog/d/synthetics_locations#id DataDatadogSyntheticsLocations#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/datadog/d/synthetics_locations datadog_synthetics_locations}
*/
export declare class DataDatadogSyntheticsLocations extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_synthetics_locations";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/datadog/d/synthetics_locations datadog_synthetics_locations} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogSyntheticsLocationsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatadogSyntheticsLocationsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _locations;
    get locations(): cdktf.StringMap;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
